2020-05-09 11:00:02 +02:00
#!/bin/bash
set -x
set -e
2018-06-21 18:33:30 +02:00
# Build fs, image
2020-06-15 23:27:21 +02:00
# This file is part of PrawnOS (https://www.prawnos.com)
2018-10-11 22:09:25 +02:00
# Copyright (c) 2018 Hal Emmerich <hal@halemmerich.com>
# PrawnOS is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License version 2
# as published by the Free Software Foundation.
# PrawnOS is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
# GNU General Public License for more details.
# You should have received a copy of the GNU General Public License
# along with PrawnOS. If not, see <https://www.gnu.org/licenses/>.
2018-06-21 18:33:30 +02:00
2018-08-24 22:05:17 +02:00
#Ensure Sudo
2018-09-06 01:35:33 +02:00
if [ ! $UID = "0" ]
then
echo "Please run this script with sudo, or as root:"
2018-08-24 22:05:17 +02:00
echo " sudo $0 $* "
exit 1
fi
2019-02-27 20:20:11 +01:00
if [ -z " $1 " ]
then
echo "No kernel version supplied"
exit 1
fi
2020-01-11 21:56:45 +01:00
if [ -z " $2 " ]
then
echo "No debian suite supplied"
exit 1
fi
if [ -z " $3 " ]
then
echo "No base file system image filename supplied"
exit 1
fi
2020-06-17 08:51:39 +02:00
if [ -z " $4 " ]
then
echo "No prawnos_root path supplied"
exit 1
fi
2020-06-21 01:44:09 +02:00
if [ -z " $5 " ]
then
echo "No shared scripts path supplied"
exit 1
fi
2020-06-30 05:39:56 +02:00
if [ -z " $6 " ]
then
echo "No Filesystem resources path supplied"
exit 1
fi
2020-06-21 01:44:09 +02:00
2019-02-27 20:20:11 +01:00
KVER = $1
2020-01-11 21:56:45 +01:00
DEBIAN_SUITE = $2
BASE = $3
2020-06-17 08:51:39 +02:00
PRAWNOS_ROOT = $4
2020-06-21 01:44:09 +02:00
PRAWNOS_SHARED_SCRIPTS = $5
2020-06-30 05:39:56 +02:00
PRAWNOS_FILESYSTEM_RESOURCES = $6
2019-02-27 20:20:11 +01:00
2020-05-20 20:00:00 +02:00
outmnt = $( mktemp -d -p " $( pwd ) " )
2018-06-21 18:33:30 +02:00
2019-02-27 20:20:11 +01:00
outdev = /dev/loop5
2018-09-06 01:35:33 +02:00
2020-06-30 05:39:56 +02:00
install_resources = $PRAWNOS_FILESYSTEM_RESOURCES /InstallResources
build_resources = $PRAWNOS_FILESYSTEM_RESOURCES
build_resources_apt = $build_resources /apt
2020-06-12 00:55:01 +02:00
2020-06-21 01:44:09 +02:00
# Import the package lists, shared scripts
source $PRAWNOS_SHARED_SCRIPTS /*
2018-06-21 18:33:30 +02:00
#A hacky way to ensure the loops are properly unmounted and the temp files are properly deleted.
2019-10-13 00:39:17 +02:00
#Without this, a reboot is sometimes required to properly clean the loop devices and ensure a clean build
2018-08-24 22:05:17 +02:00
cleanup( ) {
set +e
2018-06-21 18:33:30 +02:00
2018-08-24 22:05:17 +02:00
umount -l $outmnt > /dev/null 2>& 1
rmdir $outmnt > /dev/null 2>& 1
losetup -d $outdev > /dev/null 2>& 1
2018-06-21 18:33:30 +02:00
umount -l $outmnt > /dev/null 2>& 1
rmdir $outmnt > /dev/null 2>& 1
losetup -d $outdev > /dev/null 2>& 1
2020-05-25 22:48:18 +02:00
#delete the base file, we didn't complete our work
rm -rf $BASE
echo "FILESYSTEM BUILD FAILED"
exit 1
2018-06-21 18:33:30 +02:00
}
2018-08-24 22:05:17 +02:00
trap cleanup INT TERM EXIT
2018-06-21 18:33:30 +02:00
2020-06-30 05:39:56 +02:00
# Download, cache externally, and optionally install the specified packages
# 2: mount of the chroot
# 3: list of packages in install
# 4: if true, download, cache, and install. If false just download and cache
apt_install( ) {
PRAWNOS_ROOT = $1
shift
outmnt = $1
shift
install = $1
shift
package_list = ( " $@ " )
chroot $outmnt apt install -y -d ${ package_list [@] }
cp " $outmnt /var/cache/apt/archives/ " * " $PRAWNOS_ROOT /build/chroot-apt-cache/ " || true
if [ " $install " = true ] ; then
chroot $outmnt apt install -y ${ package_list [@] }
fi
}
2019-10-06 20:13:33 +02:00
#layout the partitons and write filesystem information
2018-06-21 18:33:30 +02:00
create_image( ) {
dd if = /dev/zero of = $1 bs = $3 count = $4 conv = sparse
parted --script $1 mklabel gpt
cgpt create $1
2019-10-06 20:13:33 +02:00
kernel_start = 8192
kernel_size = 65536
cgpt add -i 1 -t kernel -b $kernel_start -s $kernel_size -l Kernel -S 1 -T 5 -P 10 $1
#Now the main filesystem
2019-10-13 00:39:17 +02:00
root_start = $(( $kernel_start + $kernel_size ))
2018-06-21 18:33:30 +02:00
end = ` cgpt show $1 | grep 'Sec GPT table' | awk '{print $1}' `
2019-10-06 20:13:33 +02:00
root_size = $(( $end - $root_start ))
2019-10-15 15:51:16 +02:00
cgpt add -i 2 -t data -b $root_start -s $root_size -l Root $1
# $root_size is in 512 byte blocks while ext4 uses a block size of 1024 bytes
2018-06-21 18:33:30 +02:00
losetup -P $2 $1
2019-10-15 15:51:16 +02:00
mkfs.ext4 -F -b 1024 ${ 2 } p2 $(( $root_size / 2 ))
2018-06-21 18:33:30 +02:00
# mount the / partition
2019-10-13 00:39:17 +02:00
mount -o noatime ${ 2 } p2 $5
2018-06-21 18:33:30 +02:00
}
2019-05-23 00:50:16 +02:00
# create a 2GB image with the Chrome OS partition layout
2020-01-11 21:56:45 +01:00
create_image $BASE $outdev 50M 40 $outmnt
2018-06-21 18:33:30 +02:00
2018-12-01 17:33:00 +01:00
# use default debootstrap mirror if none is specified
if [ " $PRAWNOS_DEBOOTSTRAP_MIRROR " = "" ]
then
PRAWNOS_DEBOOTSTRAP_MIRROR = http://ftp.us.debian.org/debian
fi
2018-06-21 18:33:30 +02:00
# install Debian on it
2018-06-28 02:46:28 +02:00
export DEBIAN_FRONTEND = noninteractive
2020-05-25 22:48:18 +02:00
# need ca-certs, gnupg, openssl to handle https apt links and key adding for deb.prawnos.com
2020-06-19 05:50:20 +02:00
printf -v debootstrap_debs_install_joined '%s,' " ${ debootstrap_debs_install [@] } "
2020-06-19 02:36:55 +02:00
qemu-debootstrap --arch armhf $DEBIAN_SUITE \
2020-06-19 05:50:20 +02:00
--include ${ debootstrap_debs_install_joined %, } \
2020-06-30 05:39:56 +02:00
--keyring= $build_resources_apt /debian-archive-keyring.gpg \
2020-06-19 02:36:55 +02:00
$outmnt \
$PRAWNOS_DEBOOTSTRAP_MIRROR \
2020-06-30 05:39:56 +02:00
--cache-dir= $PRAWNOS_ROOT /build/debootstrap-apt-cache/
2018-08-24 22:05:17 +02:00
2020-06-19 02:36:55 +02:00
chroot $outmnt passwd -d root
2018-10-02 04:01:08 +02:00
2018-08-24 22:05:17 +02:00
#Place the config files and installer script and give them the proper permissions
2020-01-11 21:58:19 +01:00
echo -n PrawnOS > $outmnt /etc/hostname
2018-09-06 01:35:33 +02:00
cp -R $install_resources / $outmnt /InstallResources/
2019-05-23 00:50:16 +02:00
# and the icons for the lockscreen and app menu
2019-05-23 23:47:16 +02:00
mkdir $outmnt /InstallResources/icons/
cp $build_resources /logo/icons/icon-small.png $outmnt /InstallResources/icons/
cp $build_resources /logo/icons/ascii/* $outmnt /InstallResources/icons/
2018-09-06 01:35:33 +02:00
cp scripts/InstallScripts/* $outmnt /InstallResources/
2020-06-21 01:44:09 +02:00
cp $PRAWNOS_SHARED_SCRIPTS /package_lists.sh $outmnt /InstallResources/
2019-10-20 23:53:13 +02:00
cp scripts/InstallScripts/InstallPrawnOS.sh $outmnt /
2018-09-06 01:35:33 +02:00
chmod +x $outmnt /*.sh
2018-08-24 22:05:17 +02:00
2019-08-22 03:07:29 +02:00
#Setup the chroot for apt
2018-08-24 22:05:17 +02:00
#This is what https://wiki.debian.org/EmDebian/CrossDebootstrap suggests
cp /etc/hosts $outmnt /etc/
2020-06-30 05:39:56 +02:00
cp $build_resources_apt /sources.list $outmnt /etc/apt/sources.list
2020-07-02 04:23:09 +02:00
cp $build_resources_apt /prawnos.list $outmnt /etc/apt/sources.list.d/
2020-01-11 21:56:45 +01:00
sed -i -e " s/suite/ $DEBIAN_SUITE /g " $outmnt /etc/apt/sources.list
2020-06-29 00:44:59 +02:00
sed -i -e " s/suite/ $DEBIAN_SUITE /g " $outmnt /etc/apt/sources.list.d/prawnos.list
2020-01-11 21:56:45 +01:00
if [ " $DEBIAN_SUITE " != "sid" ]
2019-06-07 19:05:58 +02:00
then
# sid doesn't have updates or security; they're present for all other suites
2020-06-30 05:39:56 +02:00
cat $build_resources_apt /updates.list >> $outmnt /etc/apt/sources.list
2020-01-11 21:56:45 +01:00
sed -i -e " s/suite/ $DEBIAN_SUITE /g " $outmnt /etc/apt/sources.list
2019-06-07 19:05:58 +02:00
# sid doesn't have backports; it's present for all other suites
2020-06-30 05:39:56 +02:00
cp $build_resources_apt /backports.list $outmnt /etc/apt/sources.list.d/
2020-01-11 21:56:45 +01:00
sed -i -e " s/suite/ $DEBIAN_SUITE /g " $outmnt /etc/apt/sources.list.d/backports.list
2019-06-07 19:05:58 +02:00
#setup apt pinning
2020-06-30 05:39:56 +02:00
cp $build_resources_apt /backports.pref $outmnt /etc/apt/preferences.d/
2020-01-11 21:56:45 +01:00
sed -i -e " s/suite/ $DEBIAN_SUITE /g " $outmnt /etc/apt/preferences.d/backports.pref
2019-10-07 04:57:19 +02:00
# Install sid (unstable) as an additional source for bleeding edge packages.
2020-06-30 05:39:56 +02:00
cp $build_resources_apt /sid.list $outmnt /etc/apt/sources.list.d/
2019-06-07 19:05:58 +02:00
#setup apt pinning
2020-06-30 05:39:56 +02:00
cp $build_resources_apt /sid.pref $outmnt /etc/apt/preferences.d/
2019-06-07 19:05:58 +02:00
fi
2020-01-11 21:56:45 +01:00
if [ " $DEBIAN_SUITE " = "buster" ]
2019-06-07 19:05:58 +02:00
then
2019-10-07 04:57:19 +02:00
# Install bullseye (testing) as an additional source
2020-06-30 05:39:56 +02:00
cp $build_resources_apt /bullseye.list $outmnt /etc/apt/sources.list.d/
2019-06-07 19:05:58 +02:00
#setup apt pinning
2020-06-30 05:39:56 +02:00
cp $build_resources_apt /bullseye.pref $outmnt /etc/apt/preferences.d/
2019-06-07 19:05:58 +02:00
fi
2018-08-24 22:05:17 +02:00
2020-05-25 21:45:09 +02:00
#Bring in the deb.prawnos.com gpg keyring
2020-06-30 05:39:56 +02:00
cp $build_resources_apt /deb.prawnos.com.gpg.key $outmnt /InstallResources/
2020-05-25 21:45:09 +02:00
chroot $outmnt apt-key add /InstallResources/deb.prawnos.com.gpg.key
chroot $outmnt apt update
2018-08-24 22:05:17 +02:00
#Setup the locale
2019-01-10 20:43:03 +01:00
cp $build_resources /locale.gen $outmnt /etc/locale.gen
2018-10-02 04:01:08 +02:00
chroot $outmnt locale-gen
2018-08-24 22:05:17 +02:00
2020-06-30 05:39:56 +02:00
#Copy in the apt cache
cp " $PRAWNOS_ROOT /build/chroot-apt-cache/ " * " $outmnt /var/cache/apt/archives/ " || true
echo IMAGE SIZE
df -h
#Make apt retry on download failure
chroot $outmnt echo "APT::Acquire::Retries \"3\";" > /etc/apt/apt.conf.d/80-retries
2018-08-24 22:05:17 +02:00
#Install the base packages
2018-06-21 18:33:30 +02:00
chroot $outmnt apt update
2020-06-30 05:39:56 +02:00
apt_install $PRAWNOS_ROOT $outmnt true ${ base_debs_install [@] }
2019-09-18 03:50:27 +02:00
2019-05-23 07:19:32 +02:00
#add the live-boot fstab
cp -f $build_resources /external_fstab $outmnt /etc/fstab
2020-04-01 08:13:20 +02:00
chmod 644 $outmnt /etc/fstab
2019-05-23 07:19:32 +02:00
2018-08-24 22:05:17 +02:00
#Cleanup to reduce install size
2018-06-21 18:33:30 +02:00
chroot $outmnt apt-get autoremove --purge
chroot $outmnt apt-get clean
2018-08-24 22:05:17 +02:00
2020-06-12 00:55:01 +02:00
#Download the shared packages to be installed by Install.sh:
2020-06-30 05:39:56 +02:00
apt_install $PRAWNOS_ROOT $outmnt false ${ base_debs_download [@] }
2019-01-10 20:43:03 +01:00
2020-06-12 00:55:01 +02:00
## DEs
#Download the xfce packages to be installed by Install.sh:
2020-06-30 05:39:56 +02:00
apt_install $PRAWNOS_ROOT $outmnt false ${ xfce_debs_download [@] }
2020-05-27 01:54:00 +02:00
2020-06-12 00:55:01 +02:00
#Download the lxqt packages to be installed by Install.sh:
2020-06-30 05:39:56 +02:00
apt_install $PRAWNOS_ROOT $outmnt false ${ lxqt_debs_download [@] }
2020-05-27 01:54:00 +02:00
2020-06-12 00:55:01 +02:00
#Download the gnome packages to be installed by Install.sh:
2020-06-30 05:39:56 +02:00
apt_install $PRAWNOS_ROOT $outmnt false ${ gnome_debs_download [@] }
2019-05-22 03:00:07 +02:00
2020-06-19 02:36:55 +02:00
# we want to include all of our built packages in the apt cache for installation later, but we want to let apt download dependencies
# if required
# this gets tricky when we build some of the dependencies. To avoid issues
# first, manually cache the deb
# apt install ./local-package.deb alone doesn't work because apt will resort to downloading it from deb.prawnos.com, which we dont want
# copy into /var/cache/apt/archives to place it in the cache
#next call apt install -d on the ./filename or on the package name and apt will recognize it already has the package cached, so will only cache the dependencies
#Copy the built prawnos debs over to the image, and update apts cache
2020-06-30 05:39:56 +02:00
cd $PRAWNOS_ROOT && make filesystem_packages_install INSTALL_TARGET = $outmnt /var/cache/apt/archives/
2020-06-19 02:36:55 +02:00
chroot $outmnt apt install -y ${ prawnos_base_debs_prebuilt_install [@] }
chroot $outmnt apt install -y -d ${ prawnos_base_debs_prebuilt_download [@] }
chroot $outmnt apt install -y -d ${ prawnos_xfce_debs_prebuilt_download [@] }
2020-06-12 00:55:01 +02:00
## GPU support
#download mesa packages
2020-06-30 05:39:56 +02:00
apt_install $PRAWNOS_ROOT $outmnt false ${ mesa_debs_download [@] }
2019-01-10 20:43:03 +01:00
2018-08-24 22:05:17 +02:00
#Cleanup hosts
rm -rf $outmnt /etc/hosts #This is what https://wiki.debian.org/EmDebian/CrossDebootstrap suggests
2020-01-16 01:10:55 +01:00
echo -n "127.0.0.1 PrawnOS" > $outmnt /etc/hosts
2018-06-28 02:46:28 +02:00
2020-06-30 05:39:56 +02:00
#Cleanup apt retry
chroot $outmnt rm -f /etc/apt/apt.conf.d/80-retries
2020-05-25 22:48:18 +02:00
# do a non-error cleanup
2018-09-13 03:38:20 +02:00
umount -l $outmnt > /dev/null 2>& 1
rmdir $outmnt > /dev/null 2>& 1
losetup -d $outdev > /dev/null 2>& 1
echo "DONE!"
trap - INT TERM EXIT